<template>
  <div class="mt-3">
    <a-card class="border-0 shadow-sm">
      <a-table
        :columns="columns"
        :data-source="users"
        size="small"
        rowKey="id"
        :loading="loading"
        :row-class-name="customRowClass"
        :custom-row="customRow"
      >
        <template slot="user_avatar" slot-scope="scopeSrc">
          <a-avatar :size="22" :src="scopeSrc" />
        </template>
        <template slot="st_registry_active" slot-scope="scopeStRegistryActive">
          <a-tag
            :color="scopeStRegistryActive == 'S' ? 'blue': ''"
          >{{scopeStRegistryActive | filter-registry-active}}</a-tag>
        </template>
        <span slot="action" slot-scope="text, record">
          <a-tooltip :mouseEnterDelay="0">
            <template slot="title">Editar</template>
            <b-icon-pencil class="cursor-pointer h5 mb-0" @click="handleShowDrawerEdit(record)" />
          </a-tooltip>
        </span>
      </a-table>
    </a-card>
  </div>
</template>

<script>
import "@/filters/generic-filters/filter-registry-active";
export default {
  props: ["users", "loading"],
  data() {
    return {
      columns: [
        {
          dataIndex: "user_avatar",
          title: "Perfil",
          sortable: true,
          sortDirection: "desc",
          class: " font-weight-light",
          scopedSlots: { customRender: "user_avatar" },
        },
        {
          dataIndex: "user_username",
          title: "Nome completo",
          sortable: true,
          sortDirection: "desc",
          class: " font-weight-light",
        },
        {
          dataIndex: "user_email",
          title: "E-mail",
          sortable: true,
          class: " font-weight-light",
        },
        {
          dataIndex: "created",
          title: "Data de cadastro",
          sortable: true,
          class: " font-weight-light",
        },
        {
          dataIndex: "modified",
          title: "Última atualização",
          sortable: true,
          class: " font-weight-light",
        },
        {
          dataIndex: "st_registry_active",
          title: "Ativo",
          sortable: true,
          sortByFormatted: true,
          filterByFormatted: true,
          class: "text-center  font-weight-light",
          scopedSlots: { customRender: "st_registry_active" },
        },
        {
          dataIndex: "actions",
          title: "Ações",
          class: "text-center  font-weight-light",
          scopedSlots: { customRender: "action" },
        },
      ],
    };
  },
  methods: {
    // Emit Drawer
    handleShowDrawerForm() {
      this.$emit("emit-show-drawer-form", true);
    },
    // Emit Drawer
    handleShowDrawerEdit(user) {
      this.$emit("emit-show-drawer-edit", Object.assign({}, user));
    },
    // Emit Drawer
    handleShowDrawerView(user) {
      this.$emit("emit-show-drawer-view", Object.assign({}, user));
    },
    customRow(record) {
      return {
        on: {
          click: () => {
            this.handleShowDrawerView(record);
          },
        },
      };
    },
    customRowClass() {
      return "cursor-pointer";
    },
  },
};
</script>
